var docRef;

// не потребуется! Пусть шопер сам считает свои resolutions, мы будем работать в СМ
//var cmRes = aDoc.resolution /2.539861719;

var _L = UnitValue (0.5, 'cm'),	// длина крестика / 2
	_W = UnitValue (0.1, 'cm');	// толщина крестика / 2

var Height, Width, dlg;

// главная наша функция
main ();

function main () {
	
	if (app.documents.length == 0)
		return;
		
	docRef = app.activeDocument;
	
	createDialog ();
	if (dlg.show () != true) {
		delete dlg;
		return;
	}
		
	var step = parseFloat (dlg.msgPnl.step.et.text);
	//var x = parseFloat (dlg.msgPnl.msg.et.text);
	var T = parseFloat(dlg.msgPnl.msgTE.et.text);
	var B = parseFloat(dlg.msgPnl.msgBE.et.text);
	var L = parseFloat (dlg.msgPnl.msgLE.et.text);
	var R = parseFloat (dlg.msgPnl.msgRE.et.text);

	delete dlg;
	
	var startRulerUnits = app.preferences.rulerUnits;
 	var startTypeUnits = app.preferences.typeUnits;
 	var startDisplayDialogs = app.displayDialogs;

 	// Set Adobe Photoshop to use cm and display no dialogs
 	app.preferences.rulerUnits = Units.CM;
 	//app.preferences.typeUnits = TypeUnits.PIXELS;
	app.displayDialogs = DialogModes.NO;
	
	// настраиваем базу единиц измерения в зависимости от текущего разрешения
	UnitValue.baseUnit = UnitValue (1 / docRef.resolution, "in");
	
	// _L и _W походу не меняются, поэтому переведем их сразу в пикселы/
	_L = _L.as ('px');
	_W = _W.as ('px');

	
	Height = docRef.height;
	Width = docRef.width;
	
	// TOP
	for (var i = L; i < Width; i += step)
		drawKrest (i, T);

	// LEFT
	for (var i = T + step; i < Height; i += step)
		drawKrest (L, i);
		
	// BOTTOM
	for (var i = L; i < Width; i += step)
		drawKrest (i, Height - B);
		
	// RIGHT
	for (var i = T; i < Height; i += step)
		drawKrest (Width - R, i);
		
	//RIGHT BOTTOM CORNER
	drawKrest (Width - R, Height - B);
	docRef.selection.deselect ();
	
	
	// Reset the application preferences
 	app.preferences.rulerUnits = startRulerUnits;
 	app.preferences.typeUnits = startTypeUnits;
 	app.displayDialogs = startDisplayDialogs;
	
}

//----------DialogBOX----------

// Create an  dialog window near the upper left of the screen
function createDialog () {
	
	dlg = new Window('dialog', 'Расстановка люверсов v3');
	dlg.frameLocation = [200, 200];

	// Add a panel to hold title and 'message text' strings
	dlg.msgPnl = dlg.add('panel', undefined, 'Параметры (в см)');
	dlg.msgPnl.alignChildren = "right";
	dlg.msgPnl.step = dlg.msgPnl.add('group');
	dlg.msgPnl.msg = dlg.msgPnl.add('group');
	dlg.msgPnl.msgTE = dlg.msgPnl.add('group');
	dlg.msgPnl.msgBE = dlg.msgPnl.add('group');
	dlg.msgPnl.msgLE = dlg.msgPnl.add('group');
	dlg.msgPnl.msgRE = dlg.msgPnl.add('group');

	dlg.msgPnl.msgHeight = dlg.msgPnl.add('group');
	dlg.msgPnl.selectFolder = dlg.msgPnl.add('group');

	with (dlg.msgPnl) {
		step.st = step.add('statictext', undefined, 'Шаг между метками:');
		step.et = step.add('edittext', undefined, '15');
		step.et.preferredSize = [40,20];

		/*msg.st = msg.add('statictext', undefined, 'Расстояние до центра метки:');
		msg.et = msg.add('edittext', undefined, '2');
		msg.et.preferredSize = [40,20];*/

		msgTE.st = msgTE.add('statictext', undefined, 'Смещение сверху:');
		msgTE.et = msgTE.add('edittext', undefined, '2');
		msgTE.et.preferredSize = [40, 20];

		msgBE.st = msgBE.add('statictext', undefined, 'Смещение снизу:');
		msgBE.et = msgBE.add('edittext', undefined, '2');
		msgBE.et.preferredSize = [40, 20];

		msgLE.st = msgLE.add('statictext', undefined, 'Смещение слева:');
		msgLE.et = msgLE.add('edittext', undefined, '2');
		msgLE.et.preferredSize = [40, 20];

		msgRE.st = msgRE.add('statictext', undefined, 'Смещение справа:');
		msgRE.et = msgRE.add('edittext', undefined, '2');
		msgRE.et.preferredSize = [40, 20];  
	};

	dlg.buttons2 = dlg.add('group');
	dlg.buttons2.btnClose = dlg.buttons2.add("button", undefined, "Ok", {name: 'ok'});
	dlg.buttons2.btnClose.onClick = function () {dlg.close (true);}
	dlg.buttons2.btnCancel = dlg.buttons2.add("button", undefined, "Cancel", {name: 'cancel'});
	dlg.buttons2.btnCancel.onClick = function () {dlg.close (false);}
}


// получаем центр креста (x, y) и рисуем его
function drawKrest (x, y) {
		
	x = UnitValue (x, 'cm').as ('px');
	y = UnitValue (y, 'cm').as ('px');
	
	docRef.selection.select ([	[x-_W, y-_W],
								[x-_W, y-_L],
								[x+_W, y-_L],
								[x+_W, y-_W],
								[x+_L, y-_W],
								[x+_L, y+_W],
								[x+_W, y+_W],
								[x+_W, y+_L],
								[x-_W, y+_L],
								[x-_W, y+_W],
								[x-_L, y+_W],
								[x-_L, y-_W]	], SelectionType.REPLACE/*SelectionType.EXTEND*/, 0, false);
								
	// закрашиваем крестик через инверсию
	docRef.activeLayer.invert ();
	
}